unit FrmFolderSelector;

interface

uses

  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls, Vcl.Buttons, System.IniFiles,
  Vcl.FileCtrl,

  KnobsUtils;

type

  TFormFolderSelector = class(TForm)
    PanelBottom: TPanel;
    PanelMain: TPanel;
    BitBtnOk: TBitBtn;
    BitBtnCancel: TBitBtn;
    Label_patches: TLabel;
    Edit_patches: TEdit;
    BitBtn_patches: TBitBtn;
    Label_templates: TLabel;
    Edit_templates: TEdit;
    BitBtn_templates: TBitBtn;
    Label_sampleswaves: TLabel;
    Edit_sampleswaves: TEdit;
    BitBtn_sampleswaves: TBitBtn;
    Label_recordings: TLabel;
    Edit_recordings: TEdit;
    BitBtn_recordings: TBitBtn;
    Label_scala: TLabel;
    Edit_scala: TEdit;
    BitBtn_scala: TBitBtn;
    Label_midifiles: TLabel;
    Edit_midifiles: TEdit;
    BitBtn_midifiles: TBitBtn;
    Label_presets: TLabel;
    Edit_presets: TEdit;
    BitBtn_presets: TBitBtn;
    Label_exportsimports: TLabel;
    Edit_exportsimports: TEdit;
    BitBtn_exportsimports: TBitBtn;
    Label_csvfiles: TLabel;
    Edit_csvfiles: TEdit;
    BitBtn_csvfiles: TBitBtn;
    Label_graphs: TLabel;
    Edit_graphs: TEdit;
    BitBtn_graphs: TBitBtn;
    Label_grids: TLabel;
    Edit_grids: TEdit;
    BitBtn_grids: TBitBtn;
    Label_genes: TLabel;
    Edit_genes: TEdit;
    BitBtn_genes: TBitBtn;
    Label_textwriter: TLabel;
    Edit_textwriter: TEdit;
    BitBtn_textwriter: TBitBtn;
    FileOpenDialogSelectFolders: TFileOpenDialog;
    BitBtnLoad: TBitBtn;
    BitBtnStore: TBitBtn;
    OpenDialogFolderSetup: TOpenDialog;
    SaveDialogFolderSetup: TSaveDialog;
    Label_images: TLabel;
    Edit_images: TEdit;
    BitBtn_images: TBitBtn;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn_patchesClick(Sender: TObject);
    procedure BitBtn_templatesClick(Sender: TObject);
    procedure BitBtn_sampleswavesClick(Sender: TObject);
    procedure BitBtn_recordingsClick(Sender: TObject);
    procedure BitBtn_scalaClick(Sender: TObject);
    procedure BitBtn_midifilesClick(Sender: TObject);
    procedure BitBtn_presetsClick(Sender: TObject);
    procedure BitBtn_exportsimportsClick(Sender: TObject);
    procedure BitBtn_csvfilesClick(Sender: TObject);
    procedure BitBtn_graphsClick(Sender: TObject);
    procedure BitBtn_gridsClick(Sender: TObject);
    procedure BitBtn_genesClick(Sender: TObject);
    procedure BitBtn_textwriterClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure BitBtnLoadClick(Sender: TObject);
    procedure BitBtnStoreClick(Sender: TObject);
    procedure BitBtn_imagesClick(Sender: TObject);
  private
    FFolderPatches        : string;  FOldFolderPatches        : string;
    FFolderTemplates      : string;  FOldFolderTemplates      : string;
    FFolderSamplesWaves   : string;  FOldFolderSamplesWaves   : string;
    FFolderRecordings     : string;  FOldFolderRecordings     : string;
    FFolderScala          : string;  FOldFolderScala          : string;
    FFolderMidiFiles      : string;  FOldFolderMidiFiles      : string;
    FFolderPresets        : string;  FOldFolderPresets        : string;
    FFolderExportsImports : string;  FOldFolderExportsImports : string;
    FFolderCsvFiles       : string;  FOldFolderCsvFiles       : string;
    FFolderGraphs         : string;  FOldFolderGraphs         : string;
    FFolderGrids          : string;  FOldFolderGrids          : string;
    FFolderGenes          : string;  FOldFolderGenes          : string;
    FFolderTextWriter     : string;  FOldFolderTextWriter     : string;
    FFolderImages         : string;  FOldFolderImages         : string;
  private
    procedure   SetFolderPatches       ( const aValue: string);
    procedure   SetFolderTemplates     ( const aValue: string);
    procedure   SetFolderSamplesWaves  ( const aValue: string);
    procedure   SetFolderRecordings    ( const aValue: string);
    procedure   SetFolderScala         ( const aValue: string);
    procedure   SetFolderMidiFiles     ( const aValue: string);
    procedure   SetFolderPresets       ( const aValue: string);
    procedure   SetFolderExportsImports( const aValue: string);
    procedure   SetFolderCsvFiles      ( const aValue: string);
    procedure   SetFolderGraphs        ( const aValue: string);
    procedure   SetFolderGrids         ( const aValue: string);
    procedure   SetFolderGenes         ( const aValue: string);
    procedure   SetFolderTextWriter    ( const aValue: string);
    procedure   SetFolderImages        ( const aValue: string);
  private
    function    SelectFolder( const aDescription, aStartFolder: string): string;
    procedure   SetInitialFolders;
    procedure   SaveSettings;
    procedure   RestoreSettings;
    procedure   LoadFoldersFromFile( const aFileName: string);
    procedure   SaveFoldersToFile( const aFilename: string);
  public
    procedure   SaveToIni  ( anIniFile: TCustomIniFile; const aSection: string);
    procedure   LoadFromIni( anIniFile: TCustomIniFile; const aSection: string);
    function    Execute: Boolean;
    procedure   LoadFolderSetup;
    procedure   StoreFolderSetup;
  public
    property    FolderPatches        : string read FFolderPatches        write SetFolderPatches       ;
    property    FolderTemplates      : string read FFolderTemplates      write SetFolderTemplates     ;
    property    FolderSamplesWaves   : string read FFolderSamplesWaves   write SetFolderSamplesWaves  ;
    property    FolderRecordings     : string read FFolderRecordings     write SetFolderRecordings    ;
    property    FolderScala          : string read FFolderScala          write SetFolderScala         ;
    property    FolderMidiFiles      : string read FFolderMidiFiles      write SetFolderMidiFiles     ;
    property    FolderPresets        : string read FFolderPresets        write SetFolderPresets       ;
    property    FolderExportsImports : string read FFolderExportsImports write SetFolderExportsImports;
    property    FolderCsvFiles       : string read FFolderCsvFiles       write SetFolderCsvFiles      ;
    property    FolderGraphs         : string read FFolderGraphs         write SetFolderGraphs        ;
    property    FolderGrids          : string read FFolderGrids          write SetFolderGrids         ;
    property    FolderGenes          : string read FFolderGenes          write SetFolderGenes         ;
    property    FolderTextWriter     : string read FFolderTextWriter     write SetFolderTextWriter    ;
    property    FolderImages         : string read FFolderImages         write SetFolderImages        ;
  end;


var

  FormFolderSelector: TFormFolderSelector;


implementation

{$R *.dfm}


const

  aSection = 'FileNames';


// User area

    procedure   TFormFolderSelector.SetFolderPatches( const aValue: string);
    begin
      if   aValue <> FFolderPatches
      then begin
        FFolderPatches    := aValue;
        Edit_patches.Text := aValue;
      end;
    end;


    procedure   TFormFolderSelector.SetFolderTemplates( const aValue: string);
    begin
      if   aValue <> FFolderTemplates
      then begin
        FFolderTemplates    := aValue;
        Edit_templates.Text := aValue;
      end;
    end;


    procedure   TFormFolderSelector.SetFolderSamplesWaves( const aValue: string);
    begin
      if   aValue <> FFolderSamplesWaves
      then begin
        FFolderSamplesWaves    := aValue;
        Edit_sampleswaves.Text := aValue;
      end;
    end;


    procedure   TFormFolderSelector.SetFolderRecordings( const aValue: string);
    begin
      if   aValue <> FFolderRecordings
      then begin
        FFolderRecordings    := aValue;
        Edit_recordings.Text := aValue;
      end;
    end;


    procedure   TFormFolderSelector.SetFolderScala( const aValue: string);
    begin
      if   aValue <> FFolderScala
      then begin
        FFolderScala    := aValue;
        Edit_scala.Text := aValue;
      end;
    end;


    procedure   TFormFolderSelector.SetFolderMidiFiles( const aValue: string);
    begin
      if   aValue <> FFolderMidiFiles
      then begin
        FFolderMidiFiles    := aValue;
        Edit_midifiles.Text := aValue;
      end;
    end;


    procedure   TFormFolderSelector.SetFolderPresets( const aValue: string);
    begin
      if   aValue <> FFolderPresets
      then begin
        FFolderPresets    := aValue;
        Edit_presets.Text := aValue;
      end;
    end;


    procedure   TFormFolderSelector.SetFolderExportsImports( const aValue: string);
    begin
      if   aValue <> FFolderExportsImports
      then begin
        FFolderExportsImports    := aValue;
        Edit_exportsimports.Text := aValue;
      end;
    end;


    procedure   TFormFolderSelector.SetFolderCsvFiles( const aValue: string);
    begin
      if   aValue <> FFolderCsvFiles
      then begin
        FFolderCsvFiles    := aValue;
        Edit_csvfiles.Text := aValue;
      end;
    end;


    procedure   TFormFolderSelector.SetFolderGraphs( const aValue: string);
    begin
      if   aValue <> FFolderGraphs
      then begin
        FFolderGraphs    := aValue;
        Edit_graphs.Text := aValue;
      end;
    end;


    procedure   TFormFolderSelector.SetFolderGrids( const aValue: string);
    begin
      if   aValue <> FFolderGrids
      then begin
        FFolderGrids    := aValue;
        Edit_grids.Text := aValue;
      end;
    end;


    procedure   TFormFolderSelector.SetFolderGenes( const aValue: string);
    begin
      if   aValue <> FFolderGenes
      then begin
        FFolderGenes    := aValue;
        Edit_genes.Text := aValue;
      end;
    end;


    procedure   TFormFolderSelector.SetFolderTextWriter( const aValue: string);
    begin
      if   aValue <> FFolderTextWriter
      then begin
        FFolderTextWriter    := aValue;
        Edit_textwriter.Text := aValue;
      end;
    end;


    procedure   TFormFolderSelector.SetFolderImages( const aValue: string);
    begin
      if   aValue <> FFolderImages
      then begin
        FFolderImages    := aValue;
        Edit_images.Text := aValue;
      end;
    end;


  // private

    function    TFormFolderSelector.SelectFolder( const aDescription, aStartFolder: string): string;
    var
      aFolder : string;
    begin
      if   Win32MajorVersion >= 6
      then begin
        with FileOpenDialogSelectFolders
        do begin
          Result        := aStartFolder;
          DefaultFolder := aStartFolder;
          FileName      := aStartFolder;
          Title         := 'select a folder for : ' + aDescription;

          if   Execute
          then Result := FileName;
        end;
      end
      else begin
        aFolder := aStartFolder;

        if   SelectDirectory(
          'select a folder for : ' + aDescription,
          ExtractFileDrive( aStartFolder),
          aFolder,
          [
            sdNewFolder  ,
            sdShowEdit   ,
            sdShowShares ,
            sdNewUI      ,
            sdValidateDir
          ]
        )
        then Result := aFolder;
      end
    end;


    procedure   TFormFolderSelector.SetInitialFolders;
    begin
      FolderPatches        := ApplicationPath;
      FolderTemplates      := ApplicationPath;
      FolderSamplesWaves   := ApplicationPath;
      FolderRecordings     := ApplicationPath;
      FolderScala          := ApplicationPath;
      FolderMidiFiles      := ApplicationPath;
      FolderPresets        := ApplicationPath;
      FolderExportsImports := ApplicationPath;
      FolderCsvFiles       := ApplicationPath;
      FolderGraphs         := ApplicationPath;
      FolderGrids          := ApplicationPath;
      FolderGenes          := ApplicationPath;
      FolderTextWriter     := ApplicationPath;
      FolderImages         := ApplicationPath;
    end;


    procedure   TFormFolderSelector.SaveSettings;
    begin
      FOldFolderPatches        := FolderPatches       ;
      FOldFolderTemplates      := FolderTemplates     ;
      FOldFolderSamplesWaves   := FolderSamplesWaves  ;
      FOldFolderRecordings     := FolderRecordings    ;
      FOldFolderScala          := FolderScala         ;
      FOldFolderMidiFiles      := FolderMidiFiles     ;
      FOldFolderPresets        := FolderPresets       ;
      FOldFolderExportsImports := FolderExportsImports;
      FOldFolderCsvFiles       := FolderCsvFiles      ;
      FOldFolderGraphs         := FolderGraphs        ;
      FOldFolderGrids          := FolderGrids         ;
      FOldFolderGenes          := FolderGenes         ;
      FOldFolderTextWriter     := FolderTextWriter    ;
      FOldFolderImages         := FolderImages        ;
    end;


    procedure   TFormFolderSelector.RestoreSettings;
    begin
      FolderPatches        := FOldFolderPatches       ;
      FolderTemplates      := FOldFolderTemplates     ;
      FolderSamplesWaves   := FOldFolderSamplesWaves  ;
      FolderRecordings     := FOldFolderRecordings    ;
      FolderScala          := FOldFolderScala         ;
      FolderMidiFiles      := FOldFolderMidiFiles     ;
      FolderPresets        := FOldFolderPresets       ;
      FolderExportsImports := FOldFolderExportsImports;
      FolderCsvFiles       := FOldFolderCsvFiles      ;
      FolderGraphs         := FOldFolderGraphs        ;
      FolderGrids          := FOldFolderGrids         ;
      FolderGenes          := FOldFolderGenes         ;
      FolderTextWriter     := FOldFolderTextWriter    ;
      FolderImages         := FOldFolderImages        ;
    end;


    procedure   TFormFolderSelector.LoadFoldersFromFile( const aFileName: string);
    var
      aFile : TMemIniFile;
    begin
      if   FileExists( aFilename)
      then begin
        aFile := TMemIniFile.Create( aFileName, TEncoding.UTF8);

        with aFile
        do begin
          try
            FolderPatches        := ReadString ( aSection, 'Patches'       , FolderPatches       );
            FolderTemplates      := ReadString ( aSection, 'Templates'     , FolderTemplates     );
            FolderSamplesWaves   := ReadString ( aSection, 'SamplesWaves'  , FolderSamplesWaves  );
            FolderRecordings     := ReadString ( aSection, 'Recordings'    , FolderRecordings    );
            FolderScala          := ReadString ( aSection, 'Scala'         , FolderScala         );
            FolderMidiFiles      := ReadString ( aSection, 'MidiFiles'     , FolderMidiFiles     );
            FolderPresets        := ReadString ( aSection, 'Presets'       , FolderPresets       );
            FolderExportsImports := ReadString ( aSection, 'ExportsImports', FolderExportsImports);
            FolderCsvFiles       := ReadString ( aSection, 'CsvFiles'      , FolderCsvFiles      );
            FolderGraphs         := ReadString ( aSection, 'Graphs'        , FolderGraphs        );
            FolderGrids          := ReadString ( aSection, 'Grids'         , FolderGrids         );
            FolderGenes          := ReadString ( aSection, 'Genes'         , FolderGenes         );
            FolderTextWriter     := ReadString ( aSection, 'TextWriter'    , FolderTextWriter    );
            FolderImages         := ReadString ( aSection, 'Images'        , FolderImages        );
          finally
            DisposeOf;
          end;
        end;
      end;
    end;


    procedure   TFormFolderSelector.SaveFoldersToFile( const aFilename: string);
    var
      aFile : TMemIniFile;
    begin
      aFile := TMemIniFile.Create( aFileName, TEncoding.UTF8);

      with aFile
      do begin
        try
          WriteString ( aSection, 'Patches'       , FolderPatches       );
          WriteString ( aSection, 'Templates'     , FolderTemplates     );
          WriteString ( aSection, 'SamplesWaves'  , FolderSamplesWaves  );
          WriteString ( aSection, 'Recordings'    , FolderRecordings    );
          WriteString ( aSection, 'Scala'         , FolderScala         );
          WriteString ( aSection, 'MidiFiles'     , FolderMidiFiles     );
          WriteString ( aSection, 'Presets'       , FolderPresets       );
          WriteString ( aSection, 'ExportsImports', FolderExportsImports);
          WriteString ( aSection, 'CsvFiles'      , FolderCsvFiles      );
          WriteString ( aSection, 'Graphs'        , FolderGraphs        );
          WriteString ( aSection, 'Grids'         , FolderGrids         );
          WriteString ( aSection, 'Genes'         , FolderGenes         );
          WriteString ( aSection, 'TextWriter'    , FolderTextWriter    );
          WriteString ( aSection, 'Images'        , FolderImages        );
        finally
          UpdateFile;
          DisposeOf;
        end;
      end;
    end;


  // public

    procedure   TFormFolderSelector.SaveToIni( anIniFile: TCustomIniFile; const aSection: string);
    begin
      if   Assigned( anIniFile)
      and  ( aSection <> '')
      then begin
        with anIniFile do
        begin
          EraseSection( aSection);
          WriteInteger( aSection, 'Left'          , Left                );
          WriteInteger( aSection, 'Top'           , Top                 );
          WriteString ( aSection, 'Patches'       , FolderPatches       );
          WriteString ( aSection, 'Templates'     , FolderTemplates     );
          WriteString ( aSection, 'SamplesWaves'  , FolderSamplesWaves  );
          WriteString ( aSection, 'Recordings'    , FolderRecordings    );
          WriteString ( aSection, 'Scala'         , FolderScala         );
          WriteString ( aSection, 'MidiFiles'     , FolderMidiFiles     );
          WriteString ( aSection, 'Presets'       , FolderPresets       );
          WriteString ( aSection, 'ExportsImports', FolderExportsImports);
          WriteString ( aSection, 'CsvFiles'      , FolderCsvFiles      );
          WriteString ( aSection, 'Graphs'        , FolderGraphs        );
          WriteString ( aSection, 'Grids'         , FolderGrids         );
          WriteString ( aSection, 'Genes'         , FolderGenes         );
          WriteString ( aSection, 'TextWriter'    , FolderTextWriter    );
          WriteString ( aSection, 'Images'        , FolderImages        );
        end;
      end;
    end;


    procedure   TFormFolderSelector.LoadFromIni( anIniFile: TCustomIniFile; const aSection: string);
    var
      L, T : Integer;
    begin
      if   Assigned( anIniFile)
      and  ( aSection <> '')
      then begin
        with anIniFile do
        begin
          L                    := ReadInteger( aSection, 'Left'          , Left                );
          T                    := ReadInteger( aSection, 'Top'           , Top                 );
          FolderPatches        := ReadString ( aSection, 'Patches'       , FolderPatches       );
          FolderTemplates      := ReadString ( aSection, 'Templates'     , FolderTemplates     );
          FolderSamplesWaves   := ReadString ( aSection, 'SamplesWaves'  , FolderSamplesWaves  );
          FolderRecordings     := ReadString ( aSection, 'Recordings'    , FolderRecordings    );
          FolderScala          := ReadString ( aSection, 'Scala'         , FolderScala         );
          FolderMidiFiles      := ReadString ( aSection, 'MidiFiles'     , FolderMidiFiles     );
          FolderPresets        := ReadString ( aSection, 'Presets'       , FolderPresets       );
          FolderExportsImports := ReadString ( aSection, 'ExportsImports', FolderExportsImports);
          FolderCsvFiles       := ReadString ( aSection, 'CsvFiles'      , FolderCsvFiles      );
          FolderGraphs         := ReadString ( aSection, 'Graphs'        , FolderGraphs        );
          FolderGrids          := ReadString ( aSection, 'Grids'         , FolderGrids         );
          FolderGenes          := ReadString ( aSection, 'Genes'         , FolderGenes         );
          FolderTextWriter     := ReadString ( aSection, 'TextWriter'    , FolderTextWriter    );
          FolderImages         := ReadString ( aSection, 'Images'        , FolderImages        );

          if ( L < 0) or ( L > Screen.Width  - 10) then L := 0;
          if ( T < 0) or ( T > Screen.Height - 10) then T := 0;

          SetBounds( L, T, Width, Height);
        end;
      end;
    end;


    function    TFormFolderSelector.Execute: Boolean;
    begin
      SaveSettings;
      Result := ShowModal = mrOk;

      if   not Result
      then RestoreSettings;
    end;


    procedure   TFormFolderSelector.LoadFolderSetup;
    begin
      if   OpenDialogFolderSetup.Execute
      then LoadFoldersFromFile( OpenDialogFolderSetup.FileName);
    end;


    procedure   TFormFolderSelector.StoreFolderSetup;
    begin
      if   SaveDialogFolderSetup.Execute
      then SaveFoldersToFile( SaveDialogFolderSetup.FileName);
    end;



// Delphi area


procedure TFormFolderSelector.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if   ModalResult <> mrOk
  then RestoreSettings;
end;

procedure TFormFolderSelector.FormCreate(Sender: TObject);
begin
  SetInitialFolders;
end;

procedure TFormFolderSelector.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if   Key = VK_ESCAPE
  then begin
    ModalResult := mrCancel;
    Key         := 0;
  end
  else if Key = VK_RETURN
  then begin
    ModalResult := mrOk;
    Key         := 0;
  end
end;

procedure TFormFolderSelector.BitBtnLoadClick(Sender: TObject);
begin
  LoadFolderSetup;
end;

procedure TFormFolderSelector.BitBtnStoreClick(Sender: TObject);
begin
  StoreFolderSetup;
end;

procedure TFormFolderSelector.BitBtn_csvfilesClick(Sender: TObject);
begin
  FolderCsvFiles := SelectFolder( 'CSV files', FolderCsvFiles);
end;

procedure TFormFolderSelector.BitBtn_exportsimportsClick(Sender: TObject);
begin
  FolderExportsImports := SelectFolder( 'exports and imports', FolderExportsImports);
end;

procedure TFormFolderSelector.BitBtn_genesClick(Sender: TObject);
begin
  FolderGenes := SelectFolder( 'genes', FolderGenes);
end;

procedure TFormFolderSelector.BitBtn_graphsClick(Sender: TObject);
begin
  FolderGraphs := SelectFolder( 'graphs', FolderGraphs);
end;

procedure TFormFolderSelector.BitBtn_gridsClick(Sender: TObject);
begin
  FolderGrids := SelectFolder( 'grids', FolderGrids);
end;

procedure TFormFolderSelector.BitBtn_imagesClick(Sender: TObject);
begin
  FolderImages := SelectFolder( 'images', FolderImages);
end;

procedure TFormFolderSelector.BitBtn_midifilesClick(Sender: TObject);
begin
  FolderMidiFiles := SelectFolder( 'MIDI files', FolderMidiFiles);
end;

procedure TFormFolderSelector.BitBtn_patchesClick(Sender: TObject);
begin
  FolderPatches := SelectFolder( 'patches', FolderPatches);
end;

procedure TFormFolderSelector.BitBtn_presetsClick(Sender: TObject);
begin
  FolderPresets := SelectFolder( 'presets', FolderPresets);
end;

procedure TFormFolderSelector.BitBtn_recordingsClick(Sender: TObject);
begin
  FolderRecordings := SelectFolder( 'recordings', FolderRecordings);
end;

procedure TFormFolderSelector.BitBtn_sampleswavesClick(Sender: TObject);
begin
  FolderSamplesWaves := SelectFolder( 'samples and waves', FolderSamplesWaves);
end;

procedure TFormFolderSelector.BitBtn_scalaClick(Sender: TObject);
begin
  FolderScala := SelectFolder( 'scala', FolderScala);
end;

procedure TFormFolderSelector.BitBtn_templatesClick(Sender: TObject);
begin
  FolderTemplates := SelectFolder( 'templates', FolderTemplates);
end;

procedure TFormFolderSelector.BitBtn_textwriterClick(Sender: TObject);
begin
  FolderTextWriter := SelectFolder( 'text writer', FolderTextWriter);
end;

end.
