unit WrenStaller;

interface

uses

  WinApi.Windows, WinApi.ShellAPI,

  System.SysUtils,

  Vcl.Forms,

  Globals;


type

  TInstallationType = (
    itNone      ,
    itRelease   ,
    itPreRelease
  );


  function  RunInstaller( anInstallationType: TInstallationType): Boolean;



implementation



  function  RunInstaller( anInstallationType: TInstallationType): Boolean;
  // NOTE : values for Args parts must bequote escaped (use QuoteStr)
  var
    ExeName : string;
    Args    : string;
  begin
    Result  := True;

    if   anInstallationType = itNone
    then Exit;

    Result  := False;
    ExeName := ApplicationPath + 'installer.exe';

    if   FileExists( ExeName)
    then begin
      if   anInstallationType = itRelease
      then begin
        Args    :=
          Format(
               'title="wren full installer"'
            + ',path=%s'
            + ',url="https://bluehell.nl/installers/wren/install"'
            + ',application="%s"'
            + ',exename="%s"'
            ,
            [
                QuoteStr( IncludeTrailingPathDelimiter( ApplicationPath))
              , ApplicationFileName
              , ApplicationFileName
            ]
          );
      end
      else if anInstallationType = itPreRelease
      then begin
        Args    :=
          Format(
               'title="wren pre-release installer"'
            + ',path="%s"'
            + ',url="https://bluehell.nl/installers/wren/install_prerelease"'
            + ',application="%s"'
            + ',exename="%s"'
            ,
            [
                QuoteStr( IncludeTrailingPathDelimiter( ApplicationPath))
              , ApplicationFileName
              , ApplicationFileName
            ]
          );
      end;

      Result := ShellExecute( 0, 'open', PChar( ExeName), PChar( Args), nil, SW_SHOWNORMAL) >= 32;
    end;
  end;


end.
